## ros-noetic-cras-topic-tools 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.2)
project(cras_topic_tools)

find_package(catkin REQUIRED COMPONENTS
  cras_cpp_common
  nodelet
  roscpp
  topic_tools
)

find_package(Boost REQUIRED)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES cras_shape_shifter
)

include_directories(include ${catkin_INCLUDE_DIRS})

set(INCLUDE_BASE "${CMAKE_CURRENT_SOURCE_DIR}/include/${PROJECT_NAME}")

add_library(cras_shape_shifter src/shape_shifter.cpp)
add_dependencies(cras_shape_shifter ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_shape_shifter ${catkin_LIBRARIES})

add_library(cras_lazy_subscriber INTERFACE)
target_sources(cras_lazy_subscriber INTERFACE $<BUILD_INTERFACE:${INCLUDE_BASE}/lazy_subscriber.hpp>)
target_link_libraries(cras_lazy_subscriber INTERFACE ${catkin_LIBRARIES} Boost::boost)

add_library(cras_generic_lazy_pubsub INTERFACE)
target_sources(cras_generic_lazy_pubsub INTERFACE $<BUILD_INTERFACE:${INCLUDE_BASE}/generic_lazy_pubsub.hpp>)
target_link_libraries(cras_generic_lazy_pubsub INTERFACE ${catkin_LIBRARIES} Boost::boost)

add_library(cras_count_messages_nodelet src/count_messages.cpp)
add_dependencies(cras_count_messages_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_count_messages_nodelet ${catkin_LIBRARIES})
cras_node_from_nodelet(cras_count_messages_nodelet ${PROJECT_NAME}/count_messages.h cras::CountMessagesNodelet OUTPUT_NAME count_messages)

add_library(cras_throttle_messages_nodelet src/throttle_messages.cpp)
add_dependencies(cras_throttle_messages_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_throttle_messages_nodelet ${catkin_LIBRARIES})
cras_node_from_nodelet(cras_throttle_messages_nodelet ${PROJECT_NAME}/throttle_messages.h cras::ThrottleMessagesNodelet OUTPUT_NAME throttle ANONYMOUS)

add_library(cras_relay_nodelet src/relay.cpp)
add_dependencies(cras_relay_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_relay_nodelet ${catkin_LIBRARIES})
cras_node_from_nodelet(cras_relay_nodelet ${PROJECT_NAME}/relay.h cras::RelayNodelet OUTPUT_NAME relay ANONYMOUS)

add_library(cras_repeat_nodelet src/repeat.cpp)
add_dependencies(cras_repeat_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_repeat_nodelet cras_shape_shifter ${catkin_LIBRARIES})
cras_node_from_nodelet(cras_repeat_nodelet ${PROJECT_NAME}/repeat.h cras::RepeatMessagesNodelet OUTPUT_NAME repeat ANONYMOUS)

add_library(cras_change_header_nodelet src/change_header.cpp)
add_dependencies(cras_change_header_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_change_header_nodelet cras_shape_shifter ${catkin_LIBRARIES})
cras_node_from_nodelet(cras_change_header_nodelet ${PROJECT_NAME}/change_header.h cras::ChangeHeaderNodelet OUTPUT_NAME change_header ANONYMOUS)

add_library(cras_priority_mux_nodelet src/priority_mux.cpp)
add_dependencies(cras_priority_mux_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_priority_mux_nodelet ${catkin_LIBRARIES})
cras_node_from_nodelet(cras_priority_mux_nodelet ${PROJECT_NAME}/priority_mux.h cras::PriorityMuxNodelet OUTPUT_NAME priority_mux ANONYMOUS)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING REGEX ".*\\.hp?p?$"
)

install(TARGETS
  cras_change_header_nodelet cras_count_messages_nodelet cras_priority_mux_nodelet cras_relay_nodelet
  cras_repeat_nodelet cras_shape_shifter cras_throttle_messages_nodelet
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(FILES
  nodelet.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

catkin_install_python(PROGRAMS nodes/filter nodes/mux_replay
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(geometry_msgs REQUIRED)
  find_package(roslaunch REQUIRED)
  find_package(roslint REQUIRED)
  find_package(rostest REQUIRED)

  # catkin_lint - checks validity of package.xml and CMakeLists.txt
  # ROS buildfarm calls this without any environment and with empty rosdep cache,
  # so we have problems reading the list of packages from env
  # see https://github.com/ros-infrastructure/ros_buildfarm/issues/923
  if(DEFINED ENV{ROS_HOME})
    #catkin_lint: ignore_once env_var
    set(ROS_HOME "$ENV{ROS_HOME}")
  else()
    #catkin_lint: ignore_once env_var
    set(ROS_HOME "$ENV{HOME}/.ros")
  endif()

  #catkin_lint: ignore_once env_var
  if(DEFINED ENV{ROS_ROOT} AND EXISTS "${ROS_HOME}/rosdep/sources.cache")
    roslint_custom(catkin_lint "-W2" "--ignore" "description_boilerplate" .)
  endif()

  # Roslint C++ - checks formatting and some other rules for C++ files

  file(GLOB_RECURSE ROSLINT_INCLUDE include/*.h include/*.hpp)
  file(GLOB_RECURSE ROSLINT_SRC src/*.cpp src/*.hpp src/*.h)
  file(GLOB_RECURSE ROSLINT_TEST test/*.cpp)

  set(ROSLINT_CPP_OPTS "--extensions=h,hpp,hh,c,cpp,cc;--linelength=120;--filter=\
    -build/header_guard,-readability/namespace,-whitespace/braces,-runtime/references,\
    -build/c++11,-readability/nolint,-readability/todo,-legal/copyright")
  roslint_cpp(${ROSLINT_INCLUDE} ${ROSLINT_SRC})

  set(ROSLINT_CPP_OPTS "${ROSLINT_CPP_OPTS},-build/namespaces")  # allow "using namespace cras;" in tests
  roslint_cpp(${ROSLINT_TEST})

  roslint_add_test()

  # GTest tests

  catkin_add_gtest(test_shape_shifter test/test_shape_shifter.cpp)
  target_link_libraries(test_shape_shifter cras_shape_shifter ${catkin_LIBRARIES} ${geometry_msgs_LIBRARIES})

  add_rostest_gtest(test_cras_lazy_subscriber test/test_lazy_subscriber.test test/test_lazy_subscriber.cpp)
  target_link_libraries(test_cras_lazy_subscriber cras_lazy_subscriber ${catkin_LIBRARIES})
  roslaunch_add_file_check(test/test_lazy_subscriber.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_count_messages.test DEPENDENCIES cras_count_messages_nodelet cras_count_messages_nodelet_node)
  roslaunch_add_file_check(test/test_count_messages.test USE_TEST_DEPENDENCIES)

  add_rostest_gtest(test_cras_generic_lazy_pubsub test/test_generic_lazy_pubsub.test test/test_generic_lazy_pubsub.cpp)
  target_link_libraries(test_cras_generic_lazy_pubsub cras_generic_lazy_pubsub ${catkin_LIBRARIES})
  add_dependencies(test_cras_generic_lazy_pubsub cras_count_messages_nodelet_node)
  roslaunch_add_file_check(test/test_generic_lazy_pubsub.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_relay.test DEPENDENCIES cras_relay_nodelet_node)
  roslaunch_add_file_check(test/test_relay.test USE_TEST_DEPENDENCIES)
  add_rostest(test/test_relay_nodelet.test DEPENDENCIES cras_relay_nodelet)
  roslaunch_add_file_check(test/test_relay_nodelet.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_throttle.test DEPENDENCIES cras_throttle_messages_nodelet_node)
  roslaunch_add_file_check(test/test_throttle.test USE_TEST_DEPENDENCIES)
  add_rostest(test/test_throttle_nodelet.test DEPENDENCIES cras_throttle_messages_nodelet)
  roslaunch_add_file_check(test/test_throttle_nodelet.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_repeat.test DEPENDENCIES cras_repeat_nodelet_node)
  roslaunch_add_file_check(test/test_repeat.test USE_TEST_DEPENDENCIES)
  add_rostest(test/test_repeat_nodelet.test DEPENDENCIES cras_repeat_nodelet)
  roslaunch_add_file_check(test/test_repeat_nodelet.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_change_header.test DEPENDENCIES cras_change_header_nodelet_node)
  roslaunch_add_file_check(test/test_change_header.test USE_TEST_DEPENDENCIES)
  add_rostest(test/test_change_header_nodelet.test DEPENDENCIES cras_change_header_nodelet)
  roslaunch_add_file_check(test/test_change_header_nodelet.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_mux_replay.test)
  roslaunch_add_file_check(test/test_mux_replay.test USE_TEST_DEPENDENCIES)
  add_rostest(test/test_mux_replay_loop.test)
  roslaunch_add_file_check(test/test_mux_replay_loop.test USE_TEST_DEPENDENCIES)

  add_rostest(test/test_filter.test)
  roslaunch_add_file_check(test/test_filter.test USE_TEST_DEPENDENCIES)
endif()

=== debian/changelog ===
ros-noetic-cras-topic-tools (2.1.2-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 09 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.1.1-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.1.0-1buster) buster; urgency=high

  * Added cras::ShapeShifter as a memory-safe option for Melodic.
  * Added a method to convert a message instance to ShapeShifter.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.10-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.9-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.8-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.7-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.6-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.5-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 22 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.4-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.3-1buster) buster; urgency=high

  * Lower test_repeat thresholds even more, OSRF buildfarm is really bad at this
  * cras_py_common: Extended functionality to get closer to cras_cpp_common.
  * Improved readmes and added more badges to them.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 06 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.2-1buster) buster; urgency=high

  * Added option to change_header to apply current ROS time to stamp.
  * De-flake throttle test and enable catkin_lint when it has chance to run correctly.
  * Satisfy more pedantic Noetic linter.
  * Added website links.
  * Add linters and licenses.
  * Fixed dependency.
  * Added linters.
  * Fix catkin_lint, re-enable testing.
  * Improved comments in nodelet.xml.
  * De-flake and speed up throttle test.
  * De-flake and speed up repeater test.
  * De-flake and speed up relay test.
  * De-flake and speed up filter test.
  * De-flake and speed up change_header test.
  * Avoid threading errors when stopping nodes created by node_from_nodelet.
  * Fix compilation on GCC 7.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 28 Aug 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.1-1buster) buster; urgency=high

  * Moved hack_frame_id from cras_py_common to cras_topic_tools.
  * Moved launch files.
  * Merged cras_nodelet_topic_tools with cras_topic_tools, moved repeater and joy_repeater from cras_cpp_common to cras_topic_tools.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 25 Aug 2022 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-cras-topic-tools
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, python3-catkin-lint <!nocheck>, ros-noetic-catkin, ros-noetic-cras-cpp-common, ros-noetic-geometry-msgs <!nocheck>, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-roslaunch <!nocheck>, ros-noetic-roslint <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-rostopic <!nocheck>, ros-noetic-std-msgs <!nocheck>, ros-noetic-topic-tools
Homepage: https://wiki.ros.org/cras_topic_tools
Standards-Version: 3.9.2

Package: ros-noetic-cras-topic-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-noetic-cras-cpp-common, ros-noetic-cras-py-common, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-std-msgs, ros-noetic-topic-tools
Description: Nodes and nodeletes for safe and efficient manipulation with topics

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-cras-topic-tools//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-cras-topic-tools 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,13 @@
-cmake_minimum_required(VERSION 3.7.2)
+cmake_minimum_required(VERSION 3.10.2)
 project(cras_topic_tools)
 
 find_package(catkin REQUIRED COMPONENTS
   cras_cpp_common
+  cras_msgs
   nodelet
+  rosbag
   roscpp
+  std_msgs
   topic_tools
 )
 
@@ -12,7 +15,8 @@
 
 catkin_package(
   INCLUDE_DIRS include
-  LIBRARIES cras_shape_shifter
+  CATKIN_DEPENDS cras_cpp_common roscpp
+  LIBRARIES cras_shape_shifter cras_priority_mux
 )
 
 include_directories(include ${catkin_INCLUDE_DIRS})
@@ -23,13 +27,13 @@
 add_dependencies(cras_shape_shifter ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
 target_link_libraries(cras_shape_shifter ${catkin_LIBRARIES})
 
-add_library(cras_lazy_subscriber INTERFACE)
-target_sources(cras_lazy_subscriber INTERFACE $<BUILD_INTERFACE:${INCLUDE_BASE}/lazy_subscriber.hpp>)
-target_link_libraries(cras_lazy_subscriber INTERFACE ${catkin_LIBRARIES} Boost::boost)
+add_library(cras_lazy_subscriber src/lazy_subscriber.cpp)
+add_dependencies(cras_lazy_subscriber ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
+target_link_libraries(cras_lazy_subscriber ${catkin_LIBRARIES} Boost::boost)
 
-add_library(cras_generic_lazy_pubsub INTERFACE)
-target_sources(cras_generic_lazy_pubsub INTERFACE $<BUILD_INTERFACE:${INCLUDE_BASE}/generic_lazy_pubsub.hpp>)
-target_link_libraries(cras_generic_lazy_pubsub INTERFACE ${catkin_LIBRARIES} Boost::boost)
+add_library(cras_generic_lazy_pubsub src/generic_lazy_pubsub.cpp)
+add_dependencies(cras_generic_lazy_pubsub ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
+target_link_libraries(cras_generic_lazy_pubsub cras_lazy_subscriber cras_shape_shifter ${catkin_LIBRARIES} Boost::boost)
 
 add_library(cras_count_messages_nodelet src/count_messages.cpp)
 add_dependencies(cras_count_messages_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
@@ -38,28 +42,37 @@
 
 add_library(cras_throttle_messages_nodelet src/throttle_messages.cpp)
 add_dependencies(cras_throttle_messages_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
-target_link_libraries(cras_throttle_messages_nodelet ${catkin_LIBRARIES})
+target_link_libraries(cras_throttle_messages_nodelet cras_generic_lazy_pubsub ${catkin_LIBRARIES})
 cras_node_from_nodelet(cras_throttle_messages_nodelet ${PROJECT_NAME}/throttle_messages.h cras::ThrottleMessagesNodelet OUTPUT_NAME throttle ANONYMOUS)
 
 add_library(cras_relay_nodelet src/relay.cpp)
 add_dependencies(cras_relay_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
-target_link_libraries(cras_relay_nodelet ${catkin_LIBRARIES})
+target_link_libraries(cras_relay_nodelet cras_generic_lazy_pubsub ${catkin_LIBRARIES})
 cras_node_from_nodelet(cras_relay_nodelet ${PROJECT_NAME}/relay.h cras::RelayNodelet OUTPUT_NAME relay ANONYMOUS)
 
 add_library(cras_repeat_nodelet src/repeat.cpp)
 add_dependencies(cras_repeat_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
-target_link_libraries(cras_repeat_nodelet cras_shape_shifter ${catkin_LIBRARIES})
+target_link_libraries(cras_repeat_nodelet cras_generic_lazy_pubsub cras_shape_shifter ${catkin_LIBRARIES})
 cras_node_from_nodelet(cras_repeat_nodelet ${PROJECT_NAME}/repeat.h cras::RepeatMessagesNodelet OUTPUT_NAME repeat ANONYMOUS)
 
 add_library(cras_change_header_nodelet src/change_header.cpp)
 add_dependencies(cras_change_header_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
-target_link_libraries(cras_change_header_nodelet cras_shape_shifter ${catkin_LIBRARIES})
+target_link_libraries(cras_change_header_nodelet cras_generic_lazy_pubsub cras_shape_shifter ${catkin_LIBRARIES})
 cras_node_from_nodelet(cras_change_header_nodelet ${PROJECT_NAME}/change_header.h cras::ChangeHeaderNodelet OUTPUT_NAME change_header ANONYMOUS)
+
+add_library(cras_priority_mux src/priority_mux_base.cpp)
+add_dependencies(cras_priority_mux ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
+target_link_libraries(cras_priority_mux ${catkin_LIBRARIES})
 
 add_library(cras_priority_mux_nodelet src/priority_mux.cpp)
 add_dependencies(cras_priority_mux_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
-target_link_libraries(cras_priority_mux_nodelet ${catkin_LIBRARIES})
+target_link_libraries(cras_priority_mux_nodelet cras_priority_mux cras_shape_shifter ${catkin_LIBRARIES})
 cras_node_from_nodelet(cras_priority_mux_nodelet ${PROJECT_NAME}/priority_mux.h cras::PriorityMuxNodelet OUTPUT_NAME priority_mux ANONYMOUS)
+
+add_library(cras_heartbeat_nodelet src/heartbeat.cpp)
+add_dependencies(cras_heartbeat_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
+target_link_libraries(cras_heartbeat_nodelet cras_lazy_subscriber cras_shape_shifter ${catkin_LIBRARIES})
+cras_node_from_nodelet(cras_heartbeat_nodelet ${PROJECT_NAME}/heartbeat.h cras::HeartbeatNodelet OUTPUT_NAME heartbeat ANONYMOUS)
 
 install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
@@ -67,8 +80,8 @@
 )
 
 install(TARGETS
-  cras_change_header_nodelet cras_count_messages_nodelet cras_priority_mux_nodelet cras_relay_nodelet
-  cras_repeat_nodelet cras_shape_shifter cras_throttle_messages_nodelet
+  cras_change_header_nodelet cras_count_messages_nodelet cras_generic_lazy_pubsub cras_heartbeat_nodelet cras_lazy_subscriber
+  cras_priority_mux cras_priority_mux_nodelet cras_relay_nodelet cras_repeat_nodelet cras_shape_shifter cras_throttle_messages_nodelet
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
@@ -77,6 +90,10 @@
 install(FILES
   nodelet.xml
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
+)
+
+install(DIRECTORY data/
+  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/data
 )
 
 catkin_install_python(PROGRAMS nodes/filter nodes/mux_replay
@@ -126,6 +143,9 @@
   catkin_add_gtest(test_shape_shifter test/test_shape_shifter.cpp)
   target_link_libraries(test_shape_shifter cras_shape_shifter ${catkin_LIBRARIES} ${geometry_msgs_LIBRARIES})
 
+  catkin_add_gtest(test_priority_mux_base test/test_priority_mux_base.cpp)
+  target_link_libraries(test_priority_mux_base cras_priority_mux ${catkin_LIBRARIES})
+
   add_rostest_gtest(test_cras_lazy_subscriber test/test_lazy_subscriber.test test/test_lazy_subscriber.cpp)
   target_link_libraries(test_cras_lazy_subscriber cras_lazy_subscriber ${catkin_LIBRARIES})
   roslaunch_add_file_check(test/test_lazy_subscriber.test USE_TEST_DEPENDENCIES)
@@ -163,6 +183,14 @@
   add_rostest(test/test_mux_replay_loop.test)
   roslaunch_add_file_check(test/test_mux_replay_loop.test USE_TEST_DEPENDENCIES)
 
+  add_rostest(test/test_heartbeat.test DEPENDENCIES cras_heartbeat_nodelet_node)
+  roslaunch_add_file_check(test/test_heartbeat.test USE_TEST_DEPENDENCIES)
+  add_rostest(test/test_heartbeat_nodelet.test DEPENDENCIES cras_heartbeat_nodelet)
+  roslaunch_add_file_check(test/test_heartbeat_nodelet.test USE_TEST_DEPENDENCIES)
+
   add_rostest(test/test_filter.test)
   roslaunch_add_file_check(test/test_filter.test USE_TEST_DEPENDENCIES)
+
+  add_rostest(test/test_priority_mux.test DEPENDENCIES cras_priority_mux_nodelet_node)
+  roslaunch_add_file_check(test/test_priority_mux.test USE_TEST_DEPENDENCIES)
 endif()

=== debian/changelog ===
ros-noetic-cras-topic-tools (2.3.1-1focal) focal; urgency=high

  * shape_shifter: Fixed detection of header in messages.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 12 Jul 2023 22:00:00 -0000

ros-noetic-cras-topic-tools (2.3.0-1focal) focal; urgency=high

  * priority_mux: Added possibility to send a message just before disabling a topic.
  * shape_shifter: Improved getHeader().
  * Increased minimum CMake version to 3.10.2.
  * priority_mux: Total rewrite, now it should really work.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 11 Jul 2023 22:00:00 -0000

ros-noetic-cras-topic-tools (2.2.3-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 15 Jun 2023 22:00:00 -0000

ros-noetic-cras-topic-tools (2.2.2-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 14 May 2023 22:00:00 -0000

ros-noetic-cras-topic-tools (2.2.1-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 14 May 2023 22:00:00 -0000

ros-noetic-cras-topic-tools (2.2.0-1focal) focal; urgency=high

  * Added heartbeat.
  * Simplified lazy subscriber classes and nodelet code. Added ~tcp_no_delay param to most nodelets. API breaks included, but hopefully nothing will be affected.
    API breaks:
    - LazySubscriberBase->ConditionalSubscriber
    - LazySubscriber: callback is now passed as parameter instead of being a virtual member function
    - GenericLazyPubSub: callback is now passed as parameter instead of being a virtual member function
    - the nodelets no longer have a dedicated PubSub object that would be reusable elsewhere (the minimum probability of reuse does not outweigh the code complications it brings)
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 08 Apr 2023 22:00:00 -0000

ros-noetic-cras-topic-tools (2.1.2-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 09 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.1.1-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.1.0-1focal) focal; urgency=high

  * Added cras::ShapeShifter as a memory-safe option for Melodic.
  * Added a method to convert a message instance to ShapeShifter.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.10-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.9-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.8-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.7-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.6-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.5-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 22 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.4-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.3-1focal) focal; urgency=high

  * Lower test_repeat thresholds even more, OSRF buildfarm is really bad at this
  * cras_py_common: Extended functionality to get closer to cras_cpp_common.
  * Improved readmes and added more badges to them.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 06 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.2-1focal) focal; urgency=high

  * Added option to change_header to apply current ROS time to stamp.
  * De-flake throttle test and enable catkin_lint when it has chance to run correctly.
  * Satisfy more pedantic Noetic linter.
  * Added website links.
  * Add linters and licenses.
  * Fixed dependency.
  * Added linters.
  * Fix catkin_lint, re-enable testing.
  * Improved comments in nodelet.xml.
  * De-flake and speed up throttle test.
  * De-flake and speed up repeater test.
  * De-flake and speed up relay test.
  * De-flake and speed up filter test.
  * De-flake and speed up change_header test.
  * Avoid threading errors when stopping nodes created by node_from_nodelet.
  * Fix compilation on GCC 7.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 28 Aug 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.1-1focal) focal; urgency=high

  * Moved hack_frame_id from cras_py_common to cras_topic_tools.
  * Moved launch files.
  * Merged cras_nodelet_topic_tools with cras_topic_tools, moved repeater and joy_repeater from cras_cpp_common to cras_topic_tools.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 25 Aug 2022 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-cras-topic-tools
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, python3-catkin-lint <!nocheck>, ros-noetic-catkin, ros-noetic-cras-cpp-common, ros-noetic-cras-msgs, ros-noetic-geometry-msgs <!nocheck>, ros-noetic-nodelet, ros-noetic-rosbag, ros-noetic-roscpp, ros-noetic-roslaunch <!nocheck>, ros-noetic-roslint <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-rostopic <!nocheck>, ros-noetic-std-msgs, ros-noetic-std-msgs <!nocheck>, ros-noetic-topic-tools
Homepage: https://wiki.ros.org/cras_topic_tools
Standards-Version: 3.9.2

Package: ros-noetic-cras-topic-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-noetic-cras-cpp-common, ros-noetic-cras-msgs, ros-noetic-cras-py-common, ros-noetic-nodelet, ros-noetic-rosbag, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-std-msgs, ros-noetic-topic-tools
Description: Nodes and nodeletes for safe and efficient manipulation with topics
